<?php
// Sécurité
define('OK',1);
// Configuration
include('config.php');
// Fonctions
include('fonctions.php');

// Vérification du token CSRF
if ( !isset($_REQUEST['csrf-token']) || isset($_SESSION['csrf-token']) && ( $_REQUEST['csrf-token'] != $_SESSION['csrf-token'] ) )
  exit('{"etat":"nok","message":"Accès non autorisé"}');

// Récupération de l'action
if ( !isset($_REQUEST['action']) || !in_array($action = $_REQUEST['action'],array('prefs','docs')) )
  exit('{"etat":"nok","message":"Mauvais paramètrage"}');

// Accès professeur uniquement
if ( $autorisation < 5 )
  exit( strlen($message) ? $message : '{"etat":"nok","message":"Accès interdit"}' );

// Connexion à la base de données
$mysqli = connectsql(false);

///////////////////////////////////////////////
// Récupération des répertoires et documents //
///////////////////////////////////////////////
if ( $action == 'docs' )  {

  $mats = '<option value="-1">[Choisissez une matière]</option>';
  $reps = array( -1 =>'<option value="-1">[Choisissez une matière]</option>');
  $docs = array( -1 => '<option value="0">[Choisissez une matière]</option>', 0 => '<option value="0">[Choisissez un répertoire]</option>' );
  // Récupération des répertoires, avec le chemin complet
  $resultat = $mysqli->query("SELECT r.id, r.nom, r.matiere,
                              CONCAT( ( SELECT GROUP_CONCAT(reps.nom SEPARATOR '/') FROM reps WHERE FIND_IN_SET(reps.id,r.parents) ) ,'/') AS parents
                              FROM reps AS r LEFT JOIN matieres AS m ON m.id = r.matiere
                              WHERE FIND_IN_SET(r.matiere,'${_SESSION['matieres']}') ORDER BY m.ordre, CONCAT(parents, r.nom)");
  if ( $resultat->num_rows )  {
    while ( $r = $resultat->fetch_assoc() )  {
      if ( !isset($reps[$r['matiere']]) )  {
        $reps[$r['matiere']] = '<option value="0">[Choisissez un répertoire]</option>';
        $mats .= "<option value=\"${r['matiere']}\">".( ( strpos($r['parents'],'/') ) ? strstr($r['parents'],'/',true) : $r['nom'] ).'</option>';
      }
      $reps[$r['matiere']] .= "<option value=\"${r['id']}\">${r['parents']}${r['nom']}</option>";
      // Récupération des documents
      $docs[$r['id']] = '<option value="0">[Choisissez un document]</option>';
      $res = $mysqli->query("SELECT id, nom, SUBSTRING(ext,2) AS ext FROM docs WHERE parent = ${r['id']} AND protection < 32");
      while ( $d = $res->fetch_assoc() )  {
        $docs[$r['id']] .= "<option value=\"${d['id']}\">${d['nom']} (${d['ext']})</option>";
      }
      $res->free();
    }
    $resultat->free();
  }
  $mysqli->close();
  exit(json_encode(array('recupok'=>1,'mats'=>$mats,'reps'=>$reps,'docs'=>$docs)));

}

///////////////////////////////////////////////
// Récupération des données d'un utilisateur //
///////////////////////////////////////////////
elseif ( ( $action == 'prefs' ) && connexionlight() )  {

  // Vérification que l'identifiant est valide
  if ( isset($_REQUEST['id']) && ctype_digit($id = $_REQUEST['id']) )  {
    $resultat = $mysqli->query("SELECT nom, prenom, login, matieres, mail as mail1, (LENGTH(mdp)=40) AS valide, (LEFT(mdp,1)='*') AS demande, (LENGTH(mdp)=1) AS invitation, autorisation, mailenvoi, mailexp, mailcopie, mailliste FROM utilisateurs WHERE id = $id");
    $mysqli->close();
    if ( $resultat->num_rows )  {
      $r = $resultat->fetch_assoc();
      $resultat->free();
      // Problème d'encodage des entiers, renvoyés en tant que chaîne.
      // Semble dépendre du driver MySQL, ne prenons pas de risque
      $r['valide'] = intval($r['valide']);
      $r['demande'] = intval($r['demande']);
      $r['invitation'] = intval($r['invitation']);
      $r['autorisation'] = intval($r['autorisation']);
      $r['mailenvoi'] = intval($r['mailenvoi']);
      $r['mailcopie'] = intval($r['mailcopie']);
      $r['mailliste'] = intval($r['mailliste']);
      $r['mail2'] = '';
      $r['etat'] = 'recupok';
      exit(json_encode($r));
    }
  }
  exit('{"etat":"nok","message":"Identifiant non valide"}');

}
?>
